package genetika;

import java.util.ArrayList;
import java.util.List;
import model.Konfigurace;

/**
 * Tda pedstavujc geny. Kad uzel stromu je Genem (funkc, nebo terminlem - tdy Funkce a Terminal dd od tto tdy Gen).
 * Kad gen um vypsat sv pkazy a pkazy svch podgen (poduzl), a to ve tvaru itelnm pro uivatele a pouitelnm pro opakovan pehrn een.
 */
public class Gen {
	
	public static int nejvyssiHloubka = 0;
	
	protected String prikaz;
	protected boolean jeFunkce = false;
	protected int arita;
	protected List<Gen> geny;
	protected int hloubka;
	
	public Gen(String prikaz, int arita) {
		this.prikaz = prikaz;
		this.arita = arita;
		if (arita != 0) geny = new ArrayList<Gen>(arita);
	}
	
	public Gen() {
	}
	
	public Gen(Gen gen)	{	// koprovac konstruktor
		this.prikaz = gen.prikaz;
		this.jeFunkce = gen.jeFunkce;
		this.arita = gen.arita;
		this.hloubka = gen.hloubka;
		if (this.jeFunkce) this.geny = new ArrayList<Gen>(this.arita);
		
		for (int i = 0; i < this.arita; i++) {
			Gen podgen = new Gen(gen.geny.get(i));
			this.geny.add(podgen);
		}
	
	}
	
	public String vypis() {
		if (arita == 1) {
			return prikaz + "(" + geny.get(0).vypis() + ")";
		}
		
		if (arita == 2) {
			return prikaz + "(" + geny.get(0).vypis() + ", " + geny.get(1).vypis() + ")";
		}
		
		if (arita == 3) {
			return prikaz + "(" + geny.get(0).vypis() + ", " + geny.get(1).vypis() + ", " + geny.get(2).vypis() + ")";
		}
		
		if (arita == 0) {
			switch (prikaz) {
				case "S" :
					return "S()";
				case "Z1" :
					return "Z1()";
				case "Z2" :
					return "Z2()";
				case "Z3" :
					return "Z3()";
				case "V1" :
					return "V1()";
				case "V2" :
					return "V2()";
				case "V3" :
					return "V3()";
				default :
					break;	
			}
		}
		
		return "";
	}
	

	public void opravHloubku() {
		// po ken jsou v gen.hloubka nesprvn daje - napr. gen mel drive hloubku 4, po krizeni muze byt ve skutecnosti v hloubce 1 apod.
		
		if (hloubka == 0) {							// pokud je aktuln opravovan gen koen, m hloubku 0 a nen teba jej opravit
			for (int i = 0; i < geny.size(); i++) {
				geny.get(i).hloubka = 1;			// podgeny koenu mus mt hloubku 1
				geny.get(i).opravHloubku();
			}
		} else {									// pokud se jedn o gen hlub ne koen (libovoln podgen)
			if (isJeFunkce()) {
				for (int i = 0; i < geny.size(); i++) {
					geny.get(i).hloubka = hloubka + 1;	// podgeny mus mt hloubku o 1 vy ne aktuln gen
					geny.get(i).opravHloubku();
				}
			}
		}	
	}
	
	/** Tato funkce slou k pevodu genotypu (koene) do tabulky (tdy Pravidlo). */
	public boolean provedSeBezZobrazeni(Konfigurace konfigurace) {
		switch (prikaz) {
			case "AND" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace) && geny.get(1).provedSeBezZobrazeni(konfigurace)) {
					return true;
				} else {
					return false;
				}
				
			case "NAND" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace) && geny.get(1).provedSeBezZobrazeni(konfigurace)) {
					return false;
				} else {
					return true;
				}

			case "OR" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace) || geny.get(1).provedSeBezZobrazeni(konfigurace)) {
					return true;
				} else {
					return false;
				}
				
			case "NOR" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace) || geny.get(1).provedSeBezZobrazeni(konfigurace)) {
					return false;
				} else {
					return true;
				}
				
			case "XOR" :
				if ((geny.get(0).provedSeBezZobrazeni(konfigurace) || geny.get(1).provedSeBezZobrazeni(konfigurace)) && !((geny.get(0).provedSeBezZobrazeni(konfigurace) && geny.get(1).provedSeBezZobrazeni(konfigurace)))) {
					return true;
				} else {
					return false;
				}
				
			case "XNOR" :
				if ((geny.get(0).provedSeBezZobrazeni(konfigurace) || geny.get(1).provedSeBezZobrazeni(konfigurace)) && !((geny.get(0).provedSeBezZobrazeni(konfigurace) && geny.get(1).provedSeBezZobrazeni(konfigurace)))) {
					return false;
				} else {
					return true;
				}
				
			case "NOT" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace)) {
					return false;
				} else {
					return true;
				}
				
			case "IF" :
				if (geny.get(0).provedSeBezZobrazeni(konfigurace)) {
					return geny.get(1).provedSeBezZobrazeni(konfigurace);
				} else {
					return geny.get(2).provedSeBezZobrazeni(konfigurace);
				}
				
			case "S" :
				return konfigurace.getCANaPozici(3);
				
			case "Z1" :
				return konfigurace.getCANaPozici(2);
				
			case "Z2" :
				return konfigurace.getCANaPozici(1);

			case "Z3" :
				return konfigurace.getCANaPozici(0);
				
			case "V1" :
				return konfigurace.getCANaPozici(4);
				
			case "V2" :
				return konfigurace.getCANaPozici(5);
				
			case "V3" :
				return konfigurace.getCANaPozici(6);
				
			default :
				System.out.println("Neznm pkaz: " + prikaz);
				return false;
		}
	}
	
	
	public int getArita() {
		return arita;
	}

	public void setArita(int arita) {
		this.arita = arita;
	}

	public boolean isJeFunkce() {
		return jeFunkce;
	}

	public void setJeFunkce(boolean jeFunkce) {
		this.jeFunkce = jeFunkce;
	}

	public String getPrikaz() {
		return prikaz;
	}

	public void setPrikaz(String prikaz) {
		this.prikaz = prikaz;
	}
	
	public void setNejvyssiHloubka(Gen gen) {
		Gen.nejvyssiHloubka = 0;
		nejvyssiHloubka(gen);
	}
	
	private void nejvyssiHloubka(Gen gen) {
		if (gen.hloubka > nejvyssiHloubka) nejvyssiHloubka = gen.hloubka;
		for (int i = 0; i < gen.arita; i++) {
			gen.geny.get(i).nejvyssiHloubka(gen.geny.get(i));
		}
	}
	
	public int getHloubka() {
		return hloubka;
	}
	
	public void setHloubka(int hloubka) {
		this.hloubka = hloubka;
	}

}