package genetika;

import java.util.List;

/**
 * Tda pro uchovvn jedinc (genotyp) v populaci. Kad genotyp m vypotanou vlastn zdatnost a obsahuje koen celho stromu pedstavujcho konkrtn een.
 */
public class Genotyp {
	
	private Gen koren;
	private int zdatnost = 0;
	
	public Genotyp(int maximalniHloubka, List<Gen> mnozinaTerminalu, List<Gen> mnozinaFunkci, int metodaInicializace) {
		
		int nahodneCislo = nahodneKladneCislo(mnozinaFunkci.size());
		koren = new Funkce(mnozinaFunkci.get(nahodneCislo).getPrikaz(), mnozinaFunkci.get(nahodneCislo).getArita(), 0, maximalniHloubka, mnozinaTerminalu, mnozinaFunkci, metodaInicializace);
		
	}
	
	public Genotyp(Genotyp genotyp) {	// koprovac konstruktor
		this.koren = new Gen(genotyp.koren);	
		this.zdatnost = genotyp.zdatnost;
	}

	public int getZdatnost() {
		return zdatnost;
	}

	public void setZdatnost(int zdatnost) {
		this.zdatnost = zdatnost;
	}
	
	public int nahodneKladneCislo(int horniHranice) {		// vraci hodnoty 0 =< hodnota < horniHranice
		return (int)(Math.random() * horniHranice);
	}
	
	public Gen getKoren() {
		return koren;
	}

	public void setKoren(Funkce koren) {
		this.koren = koren;
	}

	public void setKoren(Gen koren) {
		this.koren = koren;
	}
}