package model;

/**
 * Tda reprezentujc posloupnost celulrnch automat. Celulrn automat je zastoupen boolean hodnotou v poli posloupnost.
 */
public class Konfigurace {
	
	/** true = bl = 1, false = ern = 0.*/
	private boolean[] posloupnost;
	
	/** tuto promnnou pouv PocitacCA pro uren pro genetick algoritmus, jestli se dka zmnila oproti pedchoz dce
	 *  0 = posloupnost nem jednotnou barvu (nejastj ppad),
	 *  1[X] = posloupnost m jednotnou barvu, ale pedchoz dka jet ne, druh slo znamen barvu tto dky (1 = bl, 0 = ern),
	 *  2[X] = posloupnost m barvu stejnou jako pedchoz dka, druh slo znamen barvu tto dky (1 = bl, 0 = ern),
	 *  3 = posloupnost m sice jednotnou barvu, ale ODLINOU oproti pedchoz dce a vytv nedouc vzor stdn barev. */
	private int porovnani = 0;
	
	public Konfigurace(int pocetCA) {
		posloupnost = new boolean[pocetCA];
	}
	
	public boolean getCANaPozici(int pozice) {
		return posloupnost[pozice];
	}
	
	public void setCANaPozici(int pozice, boolean hodnota) {
		this.posloupnost[pozice] = hodnota;
	}

	public boolean[] getPosloupnost() {
		return posloupnost;
	}

	public void setPosloupnost(boolean[] posloupnost) {
		this.posloupnost = posloupnost;
	}
	
	public int getPorovnani() {
		return porovnani;
	}

	public void setPorovnani(int porovnani) {
		this.porovnani = porovnani;
	}
	
	public void vygenerujNahodnouKonfiguraci() {
		for (int i = 0; i < posloupnost.length; i++) {
			if (Math.random() < 0.5) {
				posloupnost[i] = true;
			} else {
				posloupnost[i] = false;
			}
		}
	}
}