package model;

import java.util.Arrays;

/**
 * Tda pro vpoet nsledujcho dku z danho dku a pravidla (pedem pipravenho).
 */
public class PocitacCA {
	
	// true = bl = 1, false = ern = 0.
	private boolean[] posloupnost;
	private Pravidlo pravidlo;
	
	public PocitacCA() {
	}
	
	public Konfigurace vypocitejDalsiRadku(Konfigurace puvodniRadka, Pravidlo p) {
		Konfigurace novaKonfigurace = new Konfigurace(puvodniRadka.getPosloupnost().length);
		posloupnost = new boolean[puvodniRadka.getPosloupnost().length];
		pravidlo = p;
		
		boolean cerna = true;
		boolean bila = true;
		
		for (int i = 0; i < puvodniRadka.getPosloupnost().length; i++) {
			
			if (puvodniRadka.getCANaPozici(i)) {
				// true => bl barva
				cerna = false;
			} else {
				// false => ern barva
				bila = false;
			}
			
			boolean okoli[] = new boolean[pravidlo.getVelikostOkoli()];
			int indexX = (int) Math.floor(pravidlo.getVelikostOkoli() / 2);
			okoli[indexX] = puvodniRadka.getPosloupnost()[i];
			// pro libovolne liche okoli >= 3:
			for (int j = 0; j < indexX; j++) {
				// je teba oetit i ppady, kdy pesahujeme pvodn dku (zleva i zprava):
				if (! ((i - 1 - j) < 0)) {
					okoli[indexX - 1 - j] = puvodniRadka.getPosloupnost()[i - 1 - j];
				} else {
					okoli[indexX - 1 - j] = puvodniRadka.getPosloupnost()[puvodniRadka.getPosloupnost().length - 1 - j];
				}
				if (! ( (i + 1 + j) >= puvodniRadka.getPosloupnost().length)) {
					okoli[indexX + 1 + j] = puvodniRadka.getPosloupnost()[i + 1 + j];
				} else {
					okoli[indexX + 1 + j] = puvodniRadka.getPosloupnost()[j];
				}
			}
			// okoli mame naplnene, porovname ho s okolimi v pravidle, dokud nenajdeme stejne:
			boolean nenalezeno = true;
			int j = 0;
			boolean vysledek = false;
			while (nenalezeno) {
				if (Arrays.equals(pravidlo.getTabulkaOkoli().get(j), okoli)) {
					// najdeme vysledek pravidla:
					vysledek = pravidlo.getTabulkaVysledku().get(j);
					nenalezeno = false;
				}
				j++;
			}
			posloupnost[i] = vysledek;
		}
		
		novaKonfigurace.setPosloupnost(posloupnost);
		
		// Uren, zda m smysl pokraovat ve vpotu tto konfigurace v ptch dcch.
		int porovnani = 0;
		if (bila && puvodniRadka.getPorovnani() == 0) {
			porovnani = 11;
		} else if (cerna && puvodniRadka.getPorovnani() == 0) {
			porovnani = 10;
		} else if (bila && puvodniRadka.getPorovnani() == 11) {
			porovnani = 21;
		} else if (cerna && puvodniRadka.getPorovnani() == 10) {
			porovnani = 20;
		} else if (bila && puvodniRadka.getPorovnani() == 10) {
			porovnani = 3;
		} else if (cerna && puvodniRadka.getPorovnani() == 11) {
			porovnani = 3;
		}
		novaKonfigurace.setPorovnani(porovnani);
		return novaKonfigurace;
	}
	
	/** vrac: 0 - pokud je dka ern, 1 - pokud je dka bl, 2 - pokud nen dosaeno jedn barvy */
	public int zjistiBarvuRadky(Konfigurace radka) {
		int barva = 2;
		if (radka.getPosloupnost()[0] == true) {	// prvn pole bl
			barva = 1;  
		} else {									// prvn pole ern
			barva = 0;
		}
		for (int i = 1; i < radka.getPosloupnost().length; i++) {
			if ((radka.getPosloupnost()[i] == true && barva != 1) || (radka.getPosloupnost()[i] == false && barva != 0)) {
				return 2;
			}
		}
		return barva;
	}
	
	/** vrac poet blch pol v zadan konfiguraci (dce) */
	private int zjistiPocetBilych(Konfigurace radka) {
		int pocet = 0;
		for (int i = 0; i < radka.getPosloupnost().length; i++) {
			if (radka.getPosloupnost()[i] == true) pocet++;
		}
		return pocet;
	}
	
	/** vrac pevldajc barvu; true = bl, false = ern */
	public boolean zjistiPrevladajiciBarvu(Konfigurace radka) {
		boolean barva = false;
		if (zjistiPocetBilych(radka) > (radka.getPosloupnost().length + 1) / 2) {
			barva = true;
		}
		return barva;
	}
}