package model;

import genetika.GenetickyAlgoritmus;
import javax.swing.JButton;
import javax.swing.JTextArea;
import rozhrani.Mrizka;

/**
 * Tda vytvejc nov vlkno pro vlastn genetick algoritmus. Dky rozdlen vlken jsou komponenty okna aplikace aktivn i za bhu genetickho algoritmu.
 */
public class VlaknoGenetiky extends Thread {
	private Mrizka mrizka;
	private JTextArea textarea;
	private int pocetGeneraci;
	private int velikostPocatecniPopulace;
	private int maximalniInicializacniHloubkaStromu;
	private int maximalniHloubkaStromuPoKrizeni;
	private double krizeni;
	private double reprodukce;
	private double mutace;
	private double krizeniVUzluFunkce;
	private boolean zachovavatNejzdatnejsihoJedince;
	private boolean decimace;
	private int pocetAutomatuVRade;
	private int pocetRad;
	private int velikostOkoli;
	private int pocetKonfiguraciZaBehuAlgoritmu;
	private int pocetKonfiguraciProUrceniVysledku;
	private boolean prehravaniPohybu;
	private int prehravaniPoXGeneraci;
	private int metodaInicializace;
	private JButton buttonZastavit;
	
	public VlaknoGenetiky(Mrizka mrizka, JTextArea textarea, int pocetGeneraci, int velikostPocatecniPopulace, int maximalniInicializacniHloubkaStromu, int maximalniHloubkaStromuPoKrizeni, double reprodukce, double krizeni, double mutace, boolean zachovavatNejzdatnejsihoJedince, int pocetAutomatuVRade, int pocetRad, int velikostOkoli, int pocetKonfiguraciZaBehuAlgoritmu, int pocetKonfiguraciProUrceniVysledku, boolean prehravaniPohybu, int prehravaniPoXGeneraci, int metodaInicializace, JButton buttonZastavit, double krizeniVUzluFunkce, boolean decimace) {
		this.mrizka = mrizka;
		this.textarea = textarea;
		this.pocetGeneraci = pocetGeneraci;
		this.velikostPocatecniPopulace = velikostPocatecniPopulace;
		this.maximalniInicializacniHloubkaStromu = maximalniInicializacniHloubkaStromu;
		this.maximalniHloubkaStromuPoKrizeni = maximalniHloubkaStromuPoKrizeni;
		this.krizeni = krizeni;
		this.reprodukce = reprodukce;
		this.mutace = mutace;
		this.krizeniVUzluFunkce = krizeniVUzluFunkce;
		this.zachovavatNejzdatnejsihoJedince = zachovavatNejzdatnejsihoJedince;
		this.decimace = decimace;
		this.pocetAutomatuVRade = pocetAutomatuVRade;
		this.pocetRad = pocetRad;
		this.velikostOkoli = velikostOkoli;
		this.pocetKonfiguraciZaBehuAlgoritmu = pocetKonfiguraciZaBehuAlgoritmu;
		this.pocetKonfiguraciProUrceniVysledku = pocetKonfiguraciProUrceniVysledku;
		this.prehravaniPohybu = prehravaniPohybu;
		this.prehravaniPoXGeneraci = prehravaniPoXGeneraci;
		this.metodaInicializace = metodaInicializace;
		this.buttonZastavit = buttonZastavit;
	}
	
	
	public void run() {

			try {
				GenetickyAlgoritmus genetickyAlgoritmus = new GenetickyAlgoritmus(buttonZastavit);
				genetickyAlgoritmus.provadejGenetickyAlgoritmus(mrizka, textarea, pocetGeneraci, velikostPocatecniPopulace, maximalniInicializacniHloubkaStromu, maximalniHloubkaStromuPoKrizeni, krizeniVUzluFunkce, reprodukce, krizeni, mutace, zachovavatNejzdatnejsihoJedince, decimace, pocetAutomatuVRade, pocetRad, velikostOkoli, pocetKonfiguraciZaBehuAlgoritmu, pocetKonfiguraciProUrceniVysledku, prehravaniPohybu, prehravaniPoXGeneraci, metodaInicializace);
	  		} catch (Exception e) {
	  			e.printStackTrace();
	  		}
		
	}
}