package model;

import genetika.GenetickyAlgoritmus;
import javax.swing.JButton;
import javax.swing.JTextArea;
import rozhrani.Mrizka;

/**
 * Tda vytvejc nov vlkno pro testovn een na velkm mnostv potench konfigurac (1 000 000 a vce). Dky rozdlen vlken jsou komponenty okna aplikace aktivn i za bhu testu.
 */
public class VlaknoTest extends Thread {
	private Mrizka mrizka;
	private JTextArea textarea;
	private int maximalniHloubkaStromuPoKrizeni;
	private int pocetAutomatuVRade;
	private int pocetRad;
	private int velikostOkoli;
	private int pocetKonfiguraciProUrceniVysledku;
	private JButton buttonZastavit;
	
	public VlaknoTest(Mrizka mrizka, JTextArea textarea, int maximalniHloubkaStromuPoKrizeni, int pocetAutomatuVRade, int pocetRad, int velikostOkoli, int pocetKonfiguraciProUrceniVysledku, JButton buttonZastavit) {
		this.mrizka = mrizka;
		this.textarea = textarea;
		this.maximalniHloubkaStromuPoKrizeni = maximalniHloubkaStromuPoKrizeni;
		this.pocetAutomatuVRade = pocetAutomatuVRade;
		this.pocetRad = pocetRad;
		this.velikostOkoli = velikostOkoli;
		this.pocetKonfiguraciProUrceniVysledku = pocetKonfiguraciProUrceniVysledku;
		this.buttonZastavit = buttonZastavit;
	}
	
	
	public void run() {

			try {
				GenetickyAlgoritmus genetickyAlgoritmus = new GenetickyAlgoritmus(buttonZastavit);
				genetickyAlgoritmus.testGenotypu(mrizka, pocetRad, pocetKonfiguraciProUrceniVysledku, maximalniHloubkaStromuPoKrizeni, velikostOkoli, pocetAutomatuVRade, textarea);
			} catch (Exception e) {
	  			e.printStackTrace();
	  		}
		
	}
}