package rozhrani;

import java.awt.BorderLayout;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * Tda pro zobrazen npovdy.
 */
public class Napoveda extends JDialog {
	
	private static final long serialVersionUID = 1L;
	private JPanel panelNapoveda = new JPanel();
	private JTextArea textNapovedy = new JTextArea();
	private JScrollPane scrollPane;
	
	public Napoveda(JFrame oknoAplikace) {
		super(oknoAplikace, "Npovda", true);
		setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		
		textNapovedy.setText("Celulrn automaty\n\nAplikace demonstrujc vyuit genetickho programovn pi een problmu klasifikace vtiny pro jednorozmrn prostor celulrnch automat\n" +
				"Autor: Iva Dibitanzlov\n\n\n" +
				"Nastaven genetickho algoritmu:\n\n" +
				"Poet generac: maximln poet generac vytvoench v prbhu genetickho algoritmu. Algoritmus kon a dosaen tohoto potu. Vchoz hodnota: 50.\n\n" +
				"Velikost populace: poet program vytvoench, uchovanch a zpracovanch v kad generaci. Vchoz hodnota: 200.\n\n" +
				"Maximln inicializan hloubka stromu: pi tvorb inicializan populace budou uzly strom tvoeny maximln do zadan hloubky. Vchoz hodnota: 4.\n\n" +
				"Maximln hloubka stromu po ken: pi ken dvou strom budou vybrny uzly pro ken tak, aby maximln hloubka uzl potomk nepekroila zadanou hranici. Vchoz hodnota: 8.\n\n" +
				"Pravdpodobnost ken v uzlu funkce: pravdpodobnost vbru uzlu funkce msto vbru uzlu terminlu. Tato hodnota je uplatnna jak pi operaci ken, tak tak pi operaci mutace. Vchoz hodnota: 0.5.\n\n" +
				"Pravdpodobnost reprodukce: podl potu jedinc z pedchoz generace, kte budou selekn metodou vybrni do nsledujc generace a ponechni beze zmn. Vchoz hodnota: 0.1.\n\n" +
				"Pravdpodobnost ken: podl potu jedinc nsledujc generace vzniklch pomoc opertoru ken. Vchoz hodnota: 0.7.\n\n" +
				"Pravdpodobnost mutace: podl potu jedinc nsledujc generace vzniklch pomoc opertoru mutace. Vchoz hodnota: 0.2.\n\n" +
				"Elitismus: nastaven urujc, zda m bt nejzdatnj jedinec v souasn generaci automaticky zkoprovn (beze zmn) do nsledujc generace. Tento pesun nen zvisl na pravdpodobnosti reprodukce.\n\n" +
				"Inicializan metoda: zpsob tvoen strom v inicializan populaci. Grow - stromy budou postupn narstat a do maximln inicializan hloubky, piem kdykoli me bt do uzlu funkce vnoen terminl. Full - uzly funkc budou rozmstny a do maximln inicializan hloubky zmenen o 1, pot budou umstny terminly. Ramped - polovina inicializan populace vznikne metodou grow a polovina metodou full. Vchoz metoda: grow.\n\n" +
				"Decimace - tato sekundrn operace vytvo inicializan populaci 10 vt, ne byla zadna. V 10. generaci pak dojde k decimaci populace na zadanou hodnotu velikosti populace. Pi decimaci jsou jedinci v pvodn populaci seazeni podle zdatnosti a do dal generace je vybrno jen tolik nejzdatnjch jedinc, kolik je zadno parametrem velikost inicializan populace, zbytek je smazn.\n\n\n" +

				"Nastaven celulrnch automat:\n\n" +
				"Poet automat v ad: poet bunk v ad, velikost jednorozmrnho prostoru celulrnch automat. Vchoz hodnota: 149.\n\n" +
				"Poet ad: poet ad vytvoench z prvn ady pomoc pravidla - a u uivatelskho, nebo v prbhu genetickho algoritmu. Vchoz hodnota: 150.\n\n" +
				"Velikost okol: t velikost sousedstv. Uruje, kolik sousednch bunk ovlivuje vslednou barvu prostedn buky. Vdy mus jt o lich slo. Vchoz hodnota: 7.\n\n" +
				"Poet konfigurac za bhu algoritmu: bhem genetickho algoritmu bude na uvedenm potu nhodnch potench konfigurac (ad) otestovno kad pravidlo v populaci. Vchoz hodnota: 1 000.\n\n" +
				"Poet konfigurac pro uren vsledku: poet nhodnch potench ad, na nich bude otestovno nejzdatnj pravidlo po dosaen maximlnho potu generac. Vchoz hodnota: 100 000.\n\n\n" +
				
				"Tlatko Vlastn pravidlo: oteve okno pro zadn vlastnho pravidla. Ke kad kombinaci (dle zadan velikosti sousedstv) je zde vpravo zobrazena vsledn buka (ve vchozm stavu bl). Po kliknut na tuto buku my dojde ke zmn jej barvy. Takto vytvoen pravidlo lze pomoc tlatek ne Uloit, Nahrt, Zruit (bez uloen zmn zavt okno), Resetovat (uvst vechny vsledn buky do vchozho stavu) nebo Aplikovat - pout zadan pravidlo na prvn adu zobrazenou v mce v hlavnm okn.\n\n" +
				"Tlatko Barva - pepn barvu cel mky z ern na blou a naopak. V mezikroku tak pepn barvu prostedn buky v prvn ad nebo generuje nhodnou adu bunk (stejnm zpsobem jako pi bhu genetickho algoritmu).\n\n" +
				"Tlatko Uloit do PNG - ulo aktuln obsah mky jako obrzek ve formtu PNG; lze ukldat jak mku vykreslenou pomoc aplikovn vlastnho pravidla, tak mku vykreslenou za bhu genetickho algoritmu (bez nutnosti jeho zastaven).\n\n" +
				
				"Zobrazit vsledek - uruje, zda bude nejzdatnj pravidlo na nhodn vygenerovan konfiguraci otestovno a po ukonen celho genetickho algoritmu, nebo po kad zadan generaci.\n\n" +
				
				"Tlatko Spustit genetick algoritmus - zahajuje genetick algoritmus, kter je mon kdykoli peruit tlatkem Zastavit. Prbh mete sledovat v textovm poli Prbh algoritmu.\n\n" +
				"Prbh algoritmu - toto pole prbn zobrazuje informace o prbhu algoritmu, nap. aktuln generaci a dosud nejvy dosaenou zdatnost.\n\n" +
				"Vsledn een - pole, kter v prbhu genetickho algoritmu zobrazuje prv pehrvan (tedy dosud nejzdatnj) een. Lze do nj rovn zadat vlastn een a spustit jej tlatkem Pehrt een.\n\n" +
				"Tlatko test - otestuje een zadan v poli Vsledn een na potu konfigurac zadanm v poli Poet konfigurac pro uren vsledku. Po skonen vype procentuln spnost een.\n\n" +
				"Tlatka Uloit a Nahrt - slou k ukldn een aktuln vypsanho v poli Prbh algoritmu do textovho souboru a k jejich naten. Jakmile je een nateno, lze tlatkem Pehrt een zobrazit v mce.\n\n\n\n" +
				
				"Okno Vlastn pravidlo:\n\n\n" +
				"Toto okno obsahuje vechny kombinace bunk, kter me obsahovat sousedstv buky. Jejich poet zvis na parametru Velikost okol, zadanm v pedchozm okn. Vpravo vedle kad kombinace je samostatn polko (pi tvorb novho pravidla bl, jinak obsahujc barvu podle aktulnho pravidla). Pokud do tohoto polka kliknete my, zmnte jeho barvu. Po zobrazen okna jsou vechny buky bl, pokud nen zadno Vsledn een - pokud je, pak maj buky barvu danou tmto eenm.\n\n" +
				"Tlatko Uloit: ulo aktuln pravidlo do textovho souboru.\n\n" +
				"Tlatko Nast: nahraje dve uloen pravidlo z textovho souboru.\n\n" +
				"Tlatko Reset: zmn barvu vech vslednch bunk na blou (vchoz pravidlo). Pokud je ale vyplnno pole Vsledn een, vypln se vsledn pole na barvu danou tmto eenm (pro bl buky je nutn toto textov pole smazat).\n\n" +
				"Tlatko Zruit: zave okno bez uloen i aplikovn zmn v pravidle.\n\n" +
				"Tlatko Aplikovat: pouije zadan pravidlo na prvn dek v mce (ten lze ped touto aplikac upravit tlatkem Barva).\n\n" +
				"\n\n");
		textNapovedy.setEditable(false);
		textNapovedy.setLineWrap(true);
		textNapovedy.setWrapStyleWord(true);
		textNapovedy.setFont(new java.awt.Font("Verdana", 0, 12));
		textNapovedy.setRows(30);
		textNapovedy.setColumns(70);
		textNapovedy.setCaretPosition(0);
		
		panelNapoveda.add(textNapovedy, BorderLayout.CENTER);
		scrollPane = new JScrollPane(textNapovedy);
		add(scrollPane,BorderLayout.CENTER);
		
		pack();
	}
}