package rozhrani;

import genetika.*;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;

import model.Bunka;
import model.Konfigurace;
import model.VlaknoGenetiky;
import model.VlaknoTest;

/**
 * Tda hlavnho okna aplikace.
 */
public class OknoAplikace extends JFrame {

	private static final long serialVersionUID = 1L;
	private Mrizka mrizka;
	private VlaknoGenetiky vlaknoGenetiky = null;
	private VlaknoTest vlaknoTestu = null;
	private Napoveda napoveda = new Napoveda(this);
	private int kliknuti = 0;
	
	private OknoPravidlo oknoPravidlo;
	private javax.swing.JButton buttonBarva;
	private javax.swing.ButtonGroup buttonGroupInicializacniMetoda;
	private javax.swing.ButtonGroup buttonGroupPrehratPohyb;
	private javax.swing.JButton buttonNacist;
	private javax.swing.JButton buttonNapoveda;
	private javax.swing.JButton buttonPrehratReseni;
	private javax.swing.JButton buttonSpustitGenetickyAlgoritmus;
	private javax.swing.JButton buttonStop;
	private javax.swing.JButton buttonUlozit;
	private javax.swing.JButton buttonTest;
	private javax.swing.JButton buttonVlastniPravidlo;
	private javax.swing.JCheckBox checkboxDecimace;
	private javax.swing.JCheckBox checkboxZachovavatNejzdatnejsihoJedince;
	private javax.swing.JButton buttonUlozitDoBMP;
	private javax.swing.JDialog jDialog1;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JScrollPane jScrollPane2;
	private javax.swing.JLabel labelInicializacniMetoda;
	private javax.swing.JLabel labelMaximalniHloubkaStromuPoKrizeni;
	private javax.swing.JLabel labelMaximalniInicializacniHloubkaStromu;
	private javax.swing.JLabel labelNastaveni;
	private javax.swing.JLabel labelNastaveniCelularnichAutomatu;
	private javax.swing.JLabel labelPoKazdeXGeneraci2;
	private javax.swing.JLabel labelPocetAutomatuVRade;
	private javax.swing.JLabel labelPocetGeneraci;
	private javax.swing.JLabel labelPocetKonfiguraciProUrceniVysledku;
	private javax.swing.JLabel labelPocetKonfiguraciZaBehuAlgoritmu;
	private javax.swing.JLabel labelPocetRad;
	private javax.swing.JLabel labelPravdepodobnostKrizeni;
	private javax.swing.JLabel labelPravdepodobnostKrizeniVUzluFunkce;
	private javax.swing.JLabel labelPravdepodobnostMutace;
	private javax.swing.JLabel labelPravdepodobnostReprodukce;
	private javax.swing.JLabel labelPrubehAlgoritmu;
	private javax.swing.JLabel labelSekundarniOperace;
	private javax.swing.JLabel labelVelikostOkoli;
	private javax.swing.JLabel labelVelikostPocatecniPopulace;
	private javax.swing.JLabel labelVysledneReseni;
	private javax.swing.JPanel panelMrizka;
	private javax.swing.JPanel panelVpravo;
	private javax.swing.JRadioButton radioButtonPoKazdeXGeneraci1;
	private javax.swing.JRadioButton radiobuttonFull;
	private javax.swing.JRadioButton radiobuttonGrow;
	private javax.swing.JRadioButton radiobuttonNaKonci;
	private javax.swing.JRadioButton radiobuttonRamped;
	private javax.swing.JTextArea textareaPrubehAlgoritmu;
	private javax.swing.JTextArea textareaVysledneReseni;
	private javax.swing.JTextField textfieldMaximalniHloubkaStromuPoKrizeni;
	private javax.swing.JTextField textfieldMaximalniInicializacniHloubkaStromu;
	private javax.swing.JTextField textfieldPoKazdeXGeneraci;
	private javax.swing.JTextField textfieldPocetAutomatuVRade;
	private javax.swing.JTextField textfieldPocetGeneraci;
	private javax.swing.JTextField textfieldPocetKonfiguraciProUrceniVysledku;
	private javax.swing.JTextField textfieldPocetKonfiguraciZaBehuAlgoritmu;
	private javax.swing.JTextField textfieldPocetRad;
	private javax.swing.JTextField textfieldPravdepodobnostKrizeni;
	private javax.swing.JTextField textfieldPravdepodobnostKrizeniVUzluFunkce;
	private javax.swing.JTextField textfieldPravdepodobnostMutace;
	private javax.swing.JTextField textfieldPravdepodobnostReprodukce;
	private javax.swing.JTextField textfieldVelikostInicializacniPopulace;
	private javax.swing.JTextField textfieldVelikostOkoli;
	private javax.swing.JLabel zobrazitVysledek;
	private javax.swing.JScrollPane scrollPane;
	
    /**
     * Metoda inicializujc vechny komponenty a listenery hlavnho okna.
     */
	public OknoAplikace() {
		
		mrizka = new Mrizka();
		mrizka.setPreferredSize(new Dimension(mrizka.getSirka(), mrizka.getVyska()));
		panelMrizka = new JPanel();
		
		panelMrizka.setVisible(true);
		scrollPane = new javax.swing.JScrollPane(mrizka);
        scrollPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        scrollPane.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        scrollPane.setBounds(0, 0, 750, 640);
        
        panelMrizka.add(scrollPane);
        
		buttonGroupPrehratPohyb = new javax.swing.ButtonGroup();
        buttonGroupInicializacniMetoda = new javax.swing.ButtonGroup();
        jDialog1 = new javax.swing.JDialog();
        javax.swing.JTabbedPane jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        textareaVysledneReseni = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        textareaPrubehAlgoritmu = new javax.swing.JTextArea();
        labelPrubehAlgoritmu = new javax.swing.JLabel();
        labelVysledneReseni = new javax.swing.JLabel();
        panelVpravo = new javax.swing.JPanel();
        labelPravdepodobnostKrizeniVUzluFunkce = new javax.swing.JLabel();
        textfieldPravdepodobnostKrizeniVUzluFunkce = new javax.swing.JTextField();
        labelPocetAutomatuVRade = new javax.swing.JLabel();
        labelSekundarniOperace = new javax.swing.JLabel();
        textfieldPocetAutomatuVRade = new javax.swing.JTextField();
        checkboxDecimace = new javax.swing.JCheckBox();
        zobrazitVysledek = new javax.swing.JLabel();
        radiobuttonNaKonci = new javax.swing.JRadioButton();
        radioButtonPoKazdeXGeneraci1 = new javax.swing.JRadioButton();
        labelNastaveni = new javax.swing.JLabel();
        textfieldPoKazdeXGeneraci = new javax.swing.JTextField();
        labelPocetGeneraci = new javax.swing.JLabel();
        labelPoKazdeXGeneraci2 = new javax.swing.JLabel();
        textfieldPocetGeneraci = new javax.swing.JTextField();
        labelVelikostPocatecniPopulace = new javax.swing.JLabel();
        textfieldVelikostInicializacniPopulace = new javax.swing.JTextField();
        labelMaximalniInicializacniHloubkaStromu = new javax.swing.JLabel();
        textfieldMaximalniInicializacniHloubkaStromu = new javax.swing.JTextField();
        labelMaximalniHloubkaStromuPoKrizeni = new javax.swing.JLabel();
        textfieldMaximalniHloubkaStromuPoKrizeni = new javax.swing.JTextField();
        labelInicializacniMetoda = new javax.swing.JLabel();
        labelPravdepodobnostReprodukce = new javax.swing.JLabel();
        radiobuttonGrow = new javax.swing.JRadioButton();
        textfieldPravdepodobnostReprodukce = new javax.swing.JTextField();
        radiobuttonFull = new javax.swing.JRadioButton();
        labelPravdepodobnostKrizeni = new javax.swing.JLabel();
        radiobuttonRamped = new javax.swing.JRadioButton();
        textfieldPravdepodobnostKrizeni = new javax.swing.JTextField();
        labelPravdepodobnostMutace = new javax.swing.JLabel();
        textfieldPravdepodobnostMutace = new javax.swing.JTextField();
        checkboxZachovavatNejzdatnejsihoJedince = new javax.swing.JCheckBox();
        labelNastaveniCelularnichAutomatu = new javax.swing.JLabel();
        buttonSpustitGenetickyAlgoritmus = new javax.swing.JButton();
        buttonNapoveda = new javax.swing.JButton();
        buttonStop = new javax.swing.JButton();
        buttonPrehratReseni = new javax.swing.JButton();
        buttonUlozit = new javax.swing.JButton();
        buttonNacist = new javax.swing.JButton();
        buttonTest = new javax.swing.JButton();
        labelPocetRad = new javax.swing.JLabel();
        textfieldPocetRad = new javax.swing.JTextField();
        labelVelikostOkoli = new javax.swing.JLabel();
        labelPocetKonfiguraciZaBehuAlgoritmu = new javax.swing.JLabel();
        labelPocetKonfiguraciProUrceniVysledku = new javax.swing.JLabel();
        textfieldVelikostOkoli = new javax.swing.JTextField();
        textfieldPocetKonfiguraciZaBehuAlgoritmu = new javax.swing.JTextField();
        textfieldPocetKonfiguraciProUrceniVysledku = new javax.swing.JTextField();
        buttonVlastniPravidlo = new javax.swing.JButton();
        buttonBarva = new javax.swing.JButton();
        buttonUlozitDoBMP = new javax.swing.JButton();
        
        jDialog1.setName("jDialog1"); // NOI18N

        jTabbedPane1.setName("jTabbedPane1"); // NOI18N

        javax.swing.GroupLayout jDialog1Layout = new javax.swing.GroupLayout(jDialog1.getContentPane());
        jDialog1.getContentPane().setLayout(jDialog1Layout);
        jDialog1Layout.setHorizontalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialog1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 514, Short.MAX_VALUE)
                .addContainerGap())
        );
        jDialog1Layout.setVerticalGroup(
            jDialog1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jDialog1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 412, Short.MAX_VALUE)
                .addContainerGap())
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Celulrn automaty");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setFont(new java.awt.Font("Arial", 0, 11));
        setForeground(java.awt.Color.black);
        setMinimumSize(new java.awt.Dimension(1285, 880));
        setName("Form");

        panelMrizka.setName("panelMrizka");

        javax.swing.GroupLayout panelMrizkaLayout = new javax.swing.GroupLayout(panelMrizka);
        panelMrizka.setLayout(panelMrizkaLayout);
        panelMrizkaLayout.setHorizontalGroup(
            panelMrizkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelMrizkaLayout.setVerticalGroup(
            panelMrizkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        textareaVysledneReseni.setColumns(20);
        textareaVysledneReseni.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        textareaVysledneReseni.setLineWrap(true);
        textareaVysledneReseni.setRows(3);
        textareaVysledneReseni.setWrapStyleWord(true);
        textareaVysledneReseni.setName("textareaVysledneReseni"); // NOI18N
        jScrollPane1.setViewportView(textareaVysledneReseni);
        textareaVysledneReseni.getAccessibleContext().setAccessibleName("textAreaReseni");

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        textareaPrubehAlgoritmu.setColumns(20);
        textareaPrubehAlgoritmu.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        textareaPrubehAlgoritmu.setLineWrap(true);
        textareaPrubehAlgoritmu.setRows(2);
        textareaPrubehAlgoritmu.setWrapStyleWord(true);
        textareaPrubehAlgoritmu.setName("textareaPrubehAlgoritmu"); // NOI18N
        jScrollPane2.setViewportView(textareaPrubehAlgoritmu);
        textareaPrubehAlgoritmu.getAccessibleContext().setAccessibleName("textareaVypis");
        
        // pesmrovn vstupu do konzole do textovho pole Prbh algoritmu
		JTextAreaOutputStream out = new JTextAreaOutputStream(textareaPrubehAlgoritmu);
        System.setOut(new PrintStream(out));

        labelPrubehAlgoritmu.setText("Prbh algoritmu:");
        labelPrubehAlgoritmu.setName("labelPrubehAlgoritmu"); // NOI18N

        labelVysledneReseni.setText("Vsledn een:");
        labelVysledneReseni.setName("labelVysledneReseni"); // NOI18N

        panelVpravo.setName("panelVpravo"); // NOI18N

        labelPravdepodobnostKrizeniVUzluFunkce.setText("Pravdpodobnost ken v uzlu funkce:");
        labelPravdepodobnostKrizeniVUzluFunkce.setName("labelPravdepodobnostKrizeniVUzluFunkce"); // NOI18N

        textfieldPravdepodobnostKrizeniVUzluFunkce.setText("0.9");
        textfieldPravdepodobnostKrizeniVUzluFunkce.setName("textfieldPravdepodobnostKrizeniVUzluFunkce"); // NOI18N
        textfieldPravdepodobnostKrizeniVUzluFunkce.setPreferredSize(new java.awt.Dimension(29, 20));

        labelPocetAutomatuVRade.setText("Poet automat v ad:");
        labelPocetAutomatuVRade.setName("labelPocetAutomatuVRade"); // NOI18N

        labelSekundarniOperace.setText("Sekundrn operace:");
        labelSekundarniOperace.setName("labelSekundarniOperace"); // NOI18N

        textfieldPocetAutomatuVRade.setText("149");
        textfieldPocetAutomatuVRade.setName("textfieldPocetAutomatuVRade"); // NOI18N
        textfieldPocetAutomatuVRade.setPreferredSize(new java.awt.Dimension(32, 20));
        textfieldPocetAutomatuVRade.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void changedUpdate(DocumentEvent arg0) {
				if (! textfieldPocetAutomatuVRade.getText().isEmpty()) {
					zmenPocetAutomatuVRade(Integer.parseInt(textfieldPocetAutomatuVRade.getText()));
				}
			}
			@Override
			public void insertUpdate(DocumentEvent arg0) {
				if (! textfieldPocetAutomatuVRade.getText().isEmpty()) {
					zmenPocetAutomatuVRade(Integer.parseInt(textfieldPocetAutomatuVRade.getText()));
				}
			}
			@Override
			public void removeUpdate(DocumentEvent arg0) {
				if (! textfieldPocetAutomatuVRade.getText().isEmpty()) {
					zmenPocetAutomatuVRade(Integer.parseInt(textfieldPocetAutomatuVRade.getText()));
				}
			}
        	});

        checkboxDecimace.setText("decimace");
        checkboxDecimace.setName("checkboxDecimace"); // NOI18N
        checkboxDecimace.setSelected(false);

        zobrazitVysledek.setText("Zobrazit vsledek:");
        zobrazitVysledek.setName("zobrazitVysledek"); // NOI18N

        buttonGroupPrehratPohyb.add(radiobuttonNaKonci);
        radiobuttonNaKonci.setText("na konci");
        radiobuttonNaKonci.setName("radiobuttonNaKonci"); // NOI18N

        buttonGroupPrehratPohyb.add(radioButtonPoKazdeXGeneraci1);
        radioButtonPoKazdeXGeneraci1.setText("po kad");
        radioButtonPoKazdeXGeneraci1.setName("radioButtonPoKazdeXGeneraci1"); // NOI18N
        radioButtonPoKazdeXGeneraci1.setSelected(true);

        labelNastaveni.setText("Nastaven genetickho algoritmu:");
        labelNastaveni.setName("labelNastaveni"); // NOI18N

        textfieldPoKazdeXGeneraci.setText("1");
        textfieldPoKazdeXGeneraci.setName("textfieldPoKazdeXGeneraci"); // NOI18N
        textfieldPoKazdeXGeneraci.setPreferredSize(new java.awt.Dimension(28, 20));

        labelPocetGeneraci.setText("Poet generac:");
        labelPocetGeneraci.setName("labelPocetGeneraci"); // NOI18N

        labelPoKazdeXGeneraci2.setText("generaci");
        labelPoKazdeXGeneraci2.setName("labelPoKazdeXGeneraci2"); // NOI18N

        textfieldPocetGeneraci.setText("50");
        textfieldPocetGeneraci.setAutoscrolls(false);
        textfieldPocetGeneraci.setMinimumSize(new java.awt.Dimension(32, 20));
        textfieldPocetGeneraci.setName("textfieldPocetGeneraci"); // NOI18N
        textfieldPocetGeneraci.setPreferredSize(new java.awt.Dimension(32, 20));

        labelVelikostPocatecniPopulace.setText("Velikost poten populace:");
        labelVelikostPocatecniPopulace.setName("labelVelikostPocatecniPopulace"); // NOI18N

        textfieldVelikostInicializacniPopulace.setText("200");
        textfieldVelikostInicializacniPopulace.setName("textfieldVelikostInicializacniPopulace"); // NOI18N
        textfieldVelikostInicializacniPopulace.setPreferredSize(new java.awt.Dimension(32, 20));

        labelMaximalniInicializacniHloubkaStromu.setText("Maximln inicializan hloubka stromu:");
        labelMaximalniInicializacniHloubkaStromu.setName("labelMaximalniInicializacniHloubkaStromu"); // NOI18N

        textfieldMaximalniInicializacniHloubkaStromu.setText("4");
        textfieldMaximalniInicializacniHloubkaStromu.setName("textfieldMaximalniInicializacniHloubkaStromu"); // NOI18N
        textfieldMaximalniInicializacniHloubkaStromu.setPreferredSize(new java.awt.Dimension(32, 20));

        labelMaximalniHloubkaStromuPoKrizeni.setText("Maximln hloubka stromu po ken:");
        labelMaximalniHloubkaStromuPoKrizeni.setName("labelMaximalniHloubkaStromuPoKrizeni"); // NOI18N

        textfieldMaximalniHloubkaStromuPoKrizeni.setText("8");
        textfieldMaximalniHloubkaStromuPoKrizeni.setName("textfieldMaximalniHloubkaStromuPoKrizeni"); // NOI18N
        textfieldMaximalniHloubkaStromuPoKrizeni.setPreferredSize(new java.awt.Dimension(32, 20));

        labelInicializacniMetoda.setText("Inicializan metoda:");
        labelInicializacniMetoda.setName("labelInicializacniMetoda"); // NOI18N

        labelPravdepodobnostReprodukce.setText("Pravdpodobnost reprodukce:");
        labelPravdepodobnostReprodukce.setName("labelPravdepodobnostReprodukce"); // NOI18N

        buttonGroupInicializacniMetoda.add(radiobuttonGrow);
        radiobuttonGrow.setText("grow");
        radiobuttonGrow.setName("radiobuttonGrow"); // NOI18N

        textfieldPravdepodobnostReprodukce.setText("0.3");
        textfieldPravdepodobnostReprodukce.setName("textfieldPravdepodobnostReprodukce"); // NOI18N
        textfieldPravdepodobnostReprodukce.setPreferredSize(new java.awt.Dimension(28, 20));

        buttonGroupInicializacniMetoda.add(radiobuttonFull);
        radiobuttonFull.setText("full");
        radiobuttonFull.setName("radiobuttonFull"); // NOI18N

        labelPravdepodobnostKrizeni.setText("Pravdpodobnost ken:");
        labelPravdepodobnostKrizeni.setName("labelPravdepodobnostKrizeni"); // NOI18N

        buttonGroupInicializacniMetoda.add(radiobuttonRamped);
        radiobuttonRamped.setText("ramped");
        radiobuttonRamped.setName("radiobuttonRamped"); // NOI18N
        radiobuttonGrow.setSelected(true);

        textfieldPravdepodobnostKrizeni.setText("0.7");
        textfieldPravdepodobnostKrizeni.setName("textfieldPravdepodobnostKrizeni"); // NOI18N
        textfieldPravdepodobnostKrizeni.setPreferredSize(new java.awt.Dimension(28, 20));

        labelPravdepodobnostMutace.setText("Pravdpodobnost mutace:");
        labelPravdepodobnostMutace.setName("labelPravdepodobnostMutace"); // NOI18N

        textfieldPravdepodobnostMutace.setText("0.0");
        textfieldPravdepodobnostMutace.setName("textfieldPravdepodobnostMutace"); // NOI18N
        textfieldPravdepodobnostMutace.setPreferredSize(new java.awt.Dimension(28, 20));

        checkboxZachovavatNejzdatnejsihoJedince.setText("Zachovvat nejzdatnjho jedince");
        checkboxZachovavatNejzdatnejsihoJedince.setName("checkboxZachovavatNejzdatnejsihoJedince"); // NOI18N)
        checkboxZachovavatNejzdatnejsihoJedince.setSelected(true);

        labelNastaveniCelularnichAutomatu.setText("Nastaven celulrnch automat:");
        labelNastaveniCelularnichAutomatu.setName("labelNastaveniCelularnichAutomatu"); // NOI18N

        buttonSpustitGenetickyAlgoritmus.setText("Spustit genetick algoritmus");
        buttonSpustitGenetickyAlgoritmus.setName("buttonSpustitGenetickyAlgoritmus"); // NOI18N
        buttonSpustitGenetickyAlgoritmus.addActionListener(new java.awt.event.ActionListener() {
        	/**
        	 * Metoda pro vytvoen a zahjen genetickho algoritmu.
        	 */
        	public void actionPerformed(java.awt.event.ActionEvent evt) {
  
        		   	  // inicializace a validace parametr zskanch od uivatele
        			  
        			  int pocetGeneraci = 0;
        			  int velikostPocatecniPopulace = 0;
        			  int maximalniInicializacniHloubkaStromu = 0;
        			  int maximalniHloubkaStromuPoKrizeni = 0;
        			  double krizeni = 0.00;
        			  double reprodukce = 0.00;
        			  double mutace = 0.00;
        			  double pravdepodobnostKrizeniVUzluFunkce = 0.00;
        			  
        			  try {
        			  
        			  pocetGeneraci = Integer.parseInt(textfieldPocetGeneraci.getText());
        			  velikostPocatecniPopulace = Integer.parseInt(textfieldVelikostInicializacniPopulace.getText());
        			  maximalniInicializacniHloubkaStromu = Integer.parseInt(textfieldMaximalniInicializacniHloubkaStromu.getText());
        			  maximalniHloubkaStromuPoKrizeni = Integer.parseInt(textfieldMaximalniHloubkaStromuPoKrizeni.getText());
        			  
        			  krizeni = Double.parseDouble(textfieldPravdepodobnostKrizeni.getText());
        			  reprodukce = Double.parseDouble(textfieldPravdepodobnostReprodukce.getText());
        			  mutace = Double.parseDouble(textfieldPravdepodobnostMutace.getText());
        			  pravdepodobnostKrizeniVUzluFunkce = Double.parseDouble(textfieldPravdepodobnostKrizeniVUzluFunkce.getText());
        			  
        			  } catch (NumberFormatException nfe) {
        				  System.out.println("Byly zadny neplatn parametry.");
        				  return;
        			  } catch (NullPointerException npe) {
        				  System.out.println("Byly zadny neplatn parametry.");
        				  return;
        			  }
        			  
        			  boolean zachovavatNejzdatnejsihoJedince = false;
        			  if (checkboxZachovavatNejzdatnejsihoJedince.isSelected()) {
        				  zachovavatNejzdatnejsihoJedince = true;
        			  }
        			  
        			  int pocetAutomatuVRade = 0;
        			  int pocetRad = 0;
        			  int velikostOkoli = 0;
        			  int pocetKonfiguraciZaBehuAlgoritmu = 0;
        			  int pocetKonfiguraciProUrceniVysledku = 0;
        			  
        			  if (pocetGeneraci <= 0) {
        				  System.out.println("Byly zadn neplatn poet generac.");
        				  return;
        			  }
        			  
        			  if (velikostPocatecniPopulace < pocetGeneraci) {
        				  System.out.println("Velikost poten populace mus bt vt ne poet generac.");
        				  return;
        			  }
        			  
        			  if (velikostPocatecniPopulace <= 0) {
        				  System.out.println("Byla zadna neplatn velikost populace.");
        				  return;
        			  }
        			  
        			  if (maximalniInicializacniHloubkaStromu <= 0) {
        				  System.out.println("Byla zadna neplatn maximln inicializan hloubka stromu.");
        				  return;
        			  }
        			  
        			  if (maximalniHloubkaStromuPoKrizeni <= 0) {
        				  System.out.println("Byla zadna neplatn maximln hloubka stromu po ken.");
        				  return;
        			  }
        			  
        			  if (pravdepodobnostKrizeniVUzluFunkce > 1.0) {
        				  System.out.println("Byla zadna neplatn pravdpodobnost ken v uzlu funkce. Maximln hodnota je 1.0.");
        				  return;
        			  }
        			  
        			  if (krizeni > 1.0) {
        				  System.out.println("Byla zadna neplatn hodnota pro poet ken. Maximln hodnota je 1.0.");
        				  return;
        			  }
        			  
        			  if (reprodukce > 1.0) {
        				  System.out.println("Byla zadna neplatn hodnota pro poet ken. Maximln hodnota je 1.0.");
        				  return;
        			  }
        			  
        			  if (mutace > 1.0) {
        				  System.out.println("Byla zadna neplatn hodnota pro poet ken. Maximln hodnota je 1.0.");
        				  return;
        			  }
        			  
        			  if (Math.round(krizeni + reprodukce + mutace) != 1) {
        				  System.out.println("Byly zadny neplatn hodnoty pro ken, reprodukci a mutaci. Jejich souet mus bt 1.");
        				  return;
        			  }
        			  
        			  try {
        				  pocetAutomatuVRade = Integer.parseInt(textfieldPocetAutomatuVRade.getText());
        				  pocetRad = Integer.parseInt(textfieldPocetRad.getText());
        				  velikostOkoli = Integer.parseInt(textfieldVelikostOkoli.getText());
        				  pocetKonfiguraciZaBehuAlgoritmu = Integer.parseInt(textfieldPocetKonfiguraciZaBehuAlgoritmu.getText());
        				  pocetKonfiguraciProUrceniVysledku = Integer.parseInt(textfieldPocetKonfiguraciProUrceniVysledku.getText());
        			  } catch (NumberFormatException nfe) {
        				  System.out.println("Byly zadny neplatn parametry.");
        				  return;
        			  }
        			  
        			  if (pocetAutomatuVRade < 0) {
        				  System.out.println("Chyba: Byla zadna zporn hodnota potu automat v ad.");
        				  return;
        			  }
        			  
        			  if (pocetRad < 0) {
        				  System.out.println("Chyba: Byla zadna zporn hodnota potu ad.");
        				  return;
        			  }
        			  
        			  if (velikostOkoli < 0) {
        				  System.out.println("Chyba: Byla zadna zporn hodnota velikosti okol.");
        				  return;
        			  }
        			  
        			  if (velikostOkoli > 7) {
        				  System.out.println("Chyba: Maximln mon velikost okol je 7.");
        				  return;
        			  }
        			  
        			  if (pocetKonfiguraciZaBehuAlgoritmu < 0) {
        				  System.out.println("Chyba: Byla zadna zporn hodnota potu konfigurac za bhu algoritmu.");
        				  return;
        			  }
        			  
        			  if (pocetKonfiguraciProUrceniVysledku < 0) {
        				  System.out.println("Chyba: Byla zadna zporn hodnota potu konfigurac pro uren vsledku.");
        				  return;
        			  }
        			  
        			  boolean prehravatPohyb = false;
        			  if (radiobuttonNaKonci.isSelected()) {
        				  prehravatPohyb = false;
        			  }
        			  
        			  boolean decimace = false;
        			  if (checkboxDecimace.isSelected()) {
        				  decimace = true;
        			  }
        			  
        			  int prehravatPohybPoXGeneraci = 1;  
        			  if (radioButtonPoKazdeXGeneraci1.isSelected()) {
        				  prehravatPohyb = true;
        				  try {
        					  prehravatPohybPoXGeneraci = Integer.parseInt(textfieldPoKazdeXGeneraci.getText());
        					  if (prehravatPohybPoXGeneraci < 0) {
        						System.out.println("Byla zadna zporn hodnota u pehrvn een.");
        						return;
        					  }
        				  } catch (NumberFormatException nfe) {
        					  System.out.println("Byly zadny neplatn parametry.");
        					  return;
        				  }
        			  }
        			  
        			  int metodaInicializace = 0;
        			  if (radiobuttonGrow.isSelected()) {
        				  metodaInicializace = 0;
        			  }
        			  if (radiobuttonFull.isSelected()) {
        				  metodaInicializace = 1;
        			  }
        			  if (radiobuttonRamped.isSelected()) {
        				  metodaInicializace = 2;
        			  }
        			  
        			  // vytvoen novho vlkna pro genetick algoritmus (sputn genetickho algoritmu)
        			  vlaknoGenetiky = new VlaknoGenetiky(mrizka, textareaVysledneReseni, pocetGeneraci, velikostPocatecniPopulace, maximalniInicializacniHloubkaStromu - 1, maximalniHloubkaStromuPoKrizeni - 1, reprodukce, krizeni, mutace, zachovavatNejzdatnejsihoJedince, pocetAutomatuVRade, pocetRad, velikostOkoli, pocetKonfiguraciZaBehuAlgoritmu, pocetKonfiguraciProUrceniVysledku, prehravatPohyb, prehravatPohybPoXGeneraci, metodaInicializace, buttonStop, pravdepodobnostKrizeniVUzluFunkce, decimace);
        			  vlaknoGenetiky.start();
        			  
            }
        });
        
        buttonTest.setText("Test");
        buttonTest.setName("buttonTest");
        buttonTest.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro otestovn pravidla v poli Vsledn een na zadanm potu konfigurac. 
        	 */
			public void actionPerformed(ActionEvent arg0) {
				  
    			  // vytvoen novho vlkna pro genetick algoritmus (sputn genetickho algoritmu)
    			  vlaknoTestu = new VlaknoTest(mrizka, textareaVysledneReseni, Integer.parseInt(textfieldMaximalniHloubkaStromuPoKrizeni.getText()), getPocetAutomatuVRade(), Integer.parseInt(textfieldPocetRad.getText()), getVelikostOkoli(), Integer.parseInt(textfieldPocetKonfiguraciProUrceniVysledku.getText()), buttonStop);
    			  vlaknoTestu.start();
			}
		});

        buttonNapoveda.setText("Npovda");
        buttonNapoveda.setName("buttonNapoveda");
        buttonNapoveda.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro zobrazen npovdy.
        	 */
			public void actionPerformed(ActionEvent arg0) {
				napoveda.setVisible(true);
			}
		});

        buttonStop.setText("Stop");
        buttonStop.setName("buttonStop"); // NOI18N

        buttonPrehratReseni.setText("Pehrt");
        buttonPrehratReseni.setName("buttonPrehratReseni"); // NOI18N
        buttonPrehratReseni.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro proveden een zadanho do pole Vsledn een.
        	 */
			public void actionPerformed(ActionEvent arg0) {
				  GenetickyAlgoritmus genetickyAlgoritmus = new GenetickyAlgoritmus(buttonStop);
				  
				  try {
					  genetickyAlgoritmus.provedeniGenotypu(mrizka, Integer.parseInt(textfieldPocetRad.getText()), Integer.parseInt(textfieldMaximalniHloubkaStromuPoKrizeni.getText()), getVelikostOkoli(), getPocetAutomatuVRade(), textareaVysledneReseni);
				  } catch (BadLocationException e) {
					  e.printStackTrace();
				  }
			}
		});

        buttonUlozit.setText("Uloit");
        buttonUlozit.setName("buttonUlozit"); // NOI18N
        buttonUlozit.addActionListener(new java.awt.event.ActionListener() {
        	/**
        	 * Metoda pro uloen vslednho een do textovho souboru.
        	 */
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	String text = textareaVysledneReseni.getText();

                JFileChooser chooser = new JFileChooser();
                chooser.setCurrentDirectory( new File( "./") );
                int actionDialog = chooser.showSaveDialog(chooser.getParent());
                if (actionDialog == JFileChooser.APPROVE_OPTION)
                {
                    File fileName = new File(chooser.getSelectedFile() + ".txt" );

                    if(fileName.exists())
                    {
                        actionDialog = JOptionPane.showConfirmDialog(chooser.getParent(), "Nahradit existujc soubor?");
                        if (actionDialog == JOptionPane.NO_OPTION)
                            return;
                    }
                    try
                    {
                        BufferedWriter out = new BufferedWriter(new FileWriter(fileName));

                            out.write(text);
                            out.close();
                    }
                    catch(Exception e)
                    {
                         System.err.println("Error: " + e.getMessage());
                    }
                }
            	
            }
        });

        buttonNacist.setText("Nast");
        buttonNacist.setName("buttonNacist"); // NOI18N
        buttonNacist.addActionListener(new java.awt.event.ActionListener() {
        	/**
        	 * Metoda pro naten een z textovho souboru do pole Vsledn een.
        	 */
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	
                JFileChooser chooser = new JFileChooser();
                chooser.setCurrentDirectory( new File( "./") );
                int actionDialog = chooser.showOpenDialog(chooser.getParent());
                if (actionDialog == JFileChooser.APPROVE_OPTION)
                {
                	try {
                		FileReader reader = new FileReader(chooser.getSelectedFile());
                		textareaVysledneReseni.read(reader, chooser.getSelectedFile());
                	} catch (IOException ioe) {
                		System.err.println(ioe);
                	}
                }
            	
            }
        });

        labelPocetRad.setText("Poet ad:");
        labelPocetRad.setName("labelPocetRad"); // NOI18N

        textfieldPocetRad.setText("150");
        textfieldPocetRad.setName("textfieldPocetRad"); // NOI18N
        textfieldPocetRad.setPreferredSize(new java.awt.Dimension(32, 20));
        textfieldPocetRad.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void changedUpdate(DocumentEvent arg0) {
				if (! textfieldPocetRad.getText().isEmpty()) {
					zmenPocetRad(Integer.parseInt(textfieldPocetRad.getText()));
				}
			}
			@Override
			public void insertUpdate(DocumentEvent arg0) {
				if (! textfieldPocetRad.getText().isEmpty()) {
					zmenPocetRad(Integer.parseInt(textfieldPocetRad.getText()));
				}
			}
			@Override
			public void removeUpdate(DocumentEvent arg0) {
				if (! textfieldPocetRad.getText().isEmpty()) {
					zmenPocetRad(Integer.parseInt(textfieldPocetRad.getText()));
				}
			}
        	});

        labelVelikostOkoli.setText("Velikost okol:");
        labelVelikostOkoli.setName("labelVelikostOkoli"); // NOI18N

        labelPocetKonfiguraciZaBehuAlgoritmu.setText("Poet konfigurac za bhu algoritmu:");
        labelPocetKonfiguraciZaBehuAlgoritmu.setName("labelPocetKonfiguraciZaBehuAlgoritmu"); // NOI18N

        labelPocetKonfiguraciProUrceniVysledku.setText("Poet konfigurac pro uren vsledku:");
        labelPocetKonfiguraciProUrceniVysledku.setName("labelPocetKonfiguraciProUrceniVysledku"); // NOI18N

        textfieldVelikostOkoli.setText("7");
        textfieldVelikostOkoli.setName("textfieldVelikostOkoli"); // NOI18N
        textfieldVelikostOkoli.setPreferredSize(new java.awt.Dimension(32, 20));

        textfieldPocetKonfiguraciZaBehuAlgoritmu.setText("100");
        textfieldPocetKonfiguraciZaBehuAlgoritmu.setName("textfieldPocetKonfiguraciZaBehuAlgoritmu"); // NOI18N
        textfieldPocetKonfiguraciZaBehuAlgoritmu.setPreferredSize(new java.awt.Dimension(32, 20));

        textfieldPocetKonfiguraciProUrceniVysledku.setText("100000");
        textfieldPocetKonfiguraciProUrceniVysledku.setName("textfieldPocetKonfiguraciProUrceniVysledku"); // NOI18N
        textfieldPocetKonfiguraciProUrceniVysledku.setPreferredSize(new java.awt.Dimension(32, 20));

        buttonVlastniPravidlo.setText("Vlastn pravidlo");
        buttonVlastniPravidlo.setName("buttonVlastniPravidlo"); // NOI18N
        buttonVlastniPravidlo.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro zobrazen okna pro sprvu vlastnho pravidla.
        	 */
			public void actionPerformed(ActionEvent arg0) {
				vytvorOknoPravidlo();
			}
		});

        buttonBarva.setText("Barva");
        buttonBarva.setName("buttonBarva");
        buttonBarva.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro vyplnn prostoru barvou (stdav ernou nebo blou). Tak pidv doprosted pole
        	 * odlin barvy a vytv nhodnou poten konfiguraci (generovanou stejn jako v problmu klasifikace vtiny).
        	 */
			public void actionPerformed(ActionEvent arg0) {
				
				List<Konfigurace> konfList = new ArrayList<Konfigurace>();
				
				switch (kliknuti) {
				case 0:		// ve vyplnit ble
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, true);
						}
					}
					kliknuti++;
					break;
				case 1:		// ve vyplnit ble, uprosted 1 ern bod
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, true);
						}
					}
					konfList.get(0).getPosloupnost()[(int) (konfList.get(0).getPosloupnost().length / 2)] = false;
					kliknuti++;
					break;
				case 2:		// ve vyplnit ern
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, false);
						}
					}
					kliknuti++;
					break;
				case 3:		// ve vyplnit ern, uprosted 1 bl bod
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, false);
						}
					}
					konfList.get(0).getPosloupnost()[(int) (konfList.get(0).getPosloupnost().length / 2)] = true;
					kliknuti++;
					break;
				case 4:		// vyplnit nhodnou konfigurac
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, true);
						}
					}
					konfList.get(0).vygenerujNahodnouKonfiguraci();
					kliknuti++;
					break;
				case 5:		// vyplnit nhodnou konfigurac
					for (int i = 0; i < Integer.parseInt(textfieldPocetRad.getText()); i++) {
						konfList.add(new Konfigurace(Integer.parseInt(textfieldPocetAutomatuVRade.getText())));
						for (int j = 0; j < Integer.parseInt(textfieldPocetAutomatuVRade.getText()); j++) {
							konfList.get(i).setCANaPozici(j, false);
						}
					}
					konfList.get(0).vygenerujNahodnouKonfiguraci();
					kliknuti = 0;
					break;
				default:
					break;
				}
				
				mrizka.setKonfigurace(konfList);
				mrizka.repaint();
				
			}
		});

        buttonUlozitDoBMP.setText("Uloit do PNG");
        buttonUlozitDoBMP.setName("buttonUlozitDoBMP"); // NOI18N
        buttonUlozitDoBMP.addActionListener(new ActionListener() {
        	/**
        	 * Metoda pro uloen aktuln zobrazenho prostoru CA do obrzku BMP.
        	 */
			public void actionPerformed(ActionEvent arg0) {
				ulozJPanelJakoObrazek(mrizka);
			}
		});

        javax.swing.GroupLayout panelVpravoLayout = new javax.swing.GroupLayout(panelVpravo);
        panelVpravo.setLayout(panelVpravoLayout);
        panelVpravoLayout.setHorizontalGroup(
            panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelVpravoLayout.createSequentialGroup()
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelVpravoLayout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                                .addComponent(radiobuttonFull)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                                .addComponent(radiobuttonGrow)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(checkboxDecimace))
                                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                                .addComponent(radiobuttonRamped)
                                                .addGap(0, 0, Short.MAX_VALUE))))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelInicializacniMetoda)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(labelSekundarniOperace))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelMaximalniHloubkaStromuPoKrizeni)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldMaximalniHloubkaStromuPoKrizeni, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelVelikostPocatecniPopulace)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldVelikostInicializacniPopulace, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPocetGeneraci)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPocetGeneraci, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPravdepodobnostReprodukce)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPravdepodobnostReprodukce, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPravdepodobnostKrizeni)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPravdepodobnostKrizeni, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPravdepodobnostMutace)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPravdepodobnostMutace, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPravdepodobnostKrizeniVUzluFunkce)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPravdepodobnostKrizeniVUzluFunkce, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(labelMaximalniInicializacniHloubkaStromu)
                                            .addComponent(checkboxZachovavatNejzdatnejsihoJedince))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldMaximalniInicializacniHloubkaStromu, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(labelNastaveni)
                                    .addComponent(labelNastaveniCelularnichAutomatu))
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addGap(14, 14, 14)
                                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPocetAutomatuVRade)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPocetAutomatuVRade, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelPocetRad)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldPocetRad, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(labelVelikostOkoli)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(textfieldVelikostOkoli, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(labelPocetKonfiguraciZaBehuAlgoritmu)
                                            .addComponent(labelPocetKonfiguraciProUrceniVysledku))
                                        .addGap(18, 18, 18)
                                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(textfieldPocetKonfiguraciProUrceniVysledku, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(textfieldPocetKonfiguraciZaBehuAlgoritmu, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addComponent(buttonVlastniPravidlo)
                                        .addGap(7, 7, 7)
                                        .addComponent(buttonBarva)
                                        .addGap(8, 8, 8)
                                        .addComponent(buttonUlozitDoBMP)
                                        .addGap(0, 0, Short.MAX_VALUE))))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelVpravoLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(radioButtonPoKazdeXGeneraci1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(textfieldPoKazdeXGeneraci, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(labelPoKazdeXGeneraci2))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelVpravoLayout.createSequentialGroup()
                                .addComponent(buttonSpustitGenetickyAlgoritmus, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(buttonStop))))
                    .addGroup(panelVpravoLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(panelVpravoLayout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addComponent(radiobuttonNaKonci))
                                    .addComponent(zobrazitVysledek))
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(panelVpravoLayout.createSequentialGroup()
                                .addComponent(buttonPrehratReseni, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(buttonUlozit, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(buttonNacist)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(buttonTest, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(buttonNapoveda)))))
                .addContainerGap())
        );
        panelVpravoLayout.setVerticalGroup(
            panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelVpravoLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(labelNastaveni)
                .addGap(18, 18, 18)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(panelVpravoLayout.createSequentialGroup()
                        .addComponent(textfieldPocetGeneraci, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(textfieldVelikostInicializacniPopulace, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelVpravoLayout.createSequentialGroup()
                        .addComponent(labelPocetGeneraci)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(labelVelikostPocatecniPopulace)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelMaximalniInicializacniHloubkaStromu)
                    .addComponent(textfieldMaximalniInicializacniHloubkaStromu, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelMaximalniHloubkaStromuPoKrizeni)
                    .addComponent(textfieldMaximalniHloubkaStromuPoKrizeni, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelPravdepodobnostKrizeniVUzluFunkce)
                    .addComponent(textfieldPravdepodobnostKrizeniVUzluFunkce, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPravdepodobnostReprodukce)
                    .addComponent(textfieldPravdepodobnostReprodukce, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPravdepodobnostKrizeni)
                    .addComponent(textfieldPravdepodobnostKrizeni, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPravdepodobnostMutace)
                    .addComponent(textfieldPravdepodobnostMutace, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addComponent(checkboxZachovavatNejzdatnejsihoJedince, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelInicializacniMetoda)
                    .addComponent(labelSekundarniOperace))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radiobuttonGrow)
                    .addComponent(checkboxDecimace))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radiobuttonFull))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(radiobuttonRamped)
                .addGap(18, 18, 18)
                .addComponent(labelNastaveniCelularnichAutomatu, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textfieldPocetAutomatuVRade, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labelPocetAutomatuVRade))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPocetRad)
                    .addComponent(textfieldPocetRad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelVelikostOkoli)
                    .addComponent(textfieldVelikostOkoli, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPocetKonfiguraciZaBehuAlgoritmu)
                    .addComponent(textfieldPocetKonfiguraciZaBehuAlgoritmu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelPocetKonfiguraciProUrceniVysledku)
                    .addComponent(textfieldPocetKonfiguraciProUrceniVysledku, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonVlastniPravidlo)
                    .addComponent(buttonBarva)
                    .addComponent(buttonUlozitDoBMP))
                .addGap(18, 18, 18)
                .addComponent(zobrazitVysledek)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(radioButtonPoKazdeXGeneraci1)
                        .addComponent(textfieldPoKazdeXGeneraci, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(labelPoKazdeXGeneraci2))
                    .addComponent(radiobuttonNaKonci, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonSpustitGenetickyAlgoritmus)
                    .addComponent(buttonStop))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panelVpravoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonPrehratReseni)
                    .addComponent(buttonUlozit)
                    .addComponent(buttonNacist)
                    .addComponent(buttonNapoveda)
                    .addComponent(buttonTest))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        labelNastaveni.getAccessibleContext().setAccessibleName("jLabelNastaveni");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(panelMrizka, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(labelPrubehAlgoritmu)
                    .addComponent(labelVysledneReseni))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panelVpravo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(25, 25, 25))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(panelVpravo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(panelMrizka, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(labelPrubehAlgoritmu)
                        .addGap(5, 5, 5)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(labelVysledneReseni)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18))))
        );

        panelMrizka.getAccessibleContext().setAccessibleName("jPanel1");

        pack();
		setVisible(true);
		
		mrizka.grabFocus();
		
		mrizka.addMouseListener(new MouseListener() {
			
			@Override
			public void mouseReleased(MouseEvent arg0) {
			}
			
			@Override
			/**
			 * Metoda pro zadvn celulrnch automat uivatelem.
			 */
			public void mousePressed(MouseEvent e) {
				int souradniceX = Math.round(e.getX() / mrizka.getSirkaBunky());
				int souradniceY = Math.round(e.getY() / mrizka.getVyskaBunky());
				
				if (souradniceX < mrizka.getPocetSloupcu() && souradniceY < mrizka.getPocetRadku()) {
					Bunka bunka = new Bunka();
					bunka.setPozice(new Point(souradniceX, souradniceY));
					if (kliknuti < 3) {
						bunka.setBarva(Color.BLACK);
					} else {
						bunka.setBarva(Color.WHITE);
					}
					
					mrizka.nastavBunkuAVykresliBunku(new Point(souradniceX, souradniceY), bunka);
				}
			}

			@Override
			public void mouseClicked(MouseEvent e) {
			}

			@Override
			public void mouseEntered(MouseEvent e) {
			}

			@Override
			public void mouseExited(MouseEvent e) {
			}
		});
	}
	
	/**
	 * Metoda pro automatickou zmnu potu CA v ad, jakmile k n dojde.
	 * @param novyPocet
	 */
	private void zmenPocetAutomatuVRade(int novyPocet) {
		if (novyPocet > 0 || novyPocet < 1000) {
			mrizka.setPocetSloupcu(novyPocet);
			mrizka.setPreferredSize(new Dimension(mrizka.getSirka(), mrizka.getVyska()));
			scrollPane.revalidate();
			scrollPane.repaint();
		} else {
			System.out.println("Byl zadn neplatn poet automat v ad.");
		}
	}
	
	/**
	 * Metoda pro automatickou zmnu potu ad, jakmile k n dojde.
	 * @param novyPocet
	 */
	private void zmenPocetRad(int novyPocet) {
		if (novyPocet > 0 || novyPocet < 1000) {
			mrizka.setPocetRadku(novyPocet);
			mrizka.setPreferredSize(new Dimension(mrizka.getSirka(), mrizka.getVyska()));
			scrollPane.revalidate();
			scrollPane.repaint();
		} else {
			System.out.println("Byl zadn neplatn poet ad.");
		}
	}
	
	public int getVelikostOkoli() {
		int vel = 0;
		vel = Integer.parseInt(textfieldVelikostOkoli.getText());
		return vel;
	}
	
	public int getPocetAutomatuVRade() {
		int pocet = 0;
		pocet = Integer.parseInt(textfieldPocetAutomatuVRade.getText());
		return pocet;
	}
	
	public int getPocetAutomatuVeSloupci() {
		int pocet = 0;
		pocet = Integer.parseInt(textfieldPocetRad.getText());
		return pocet;
	}
	
	public void setVelikostOkoli(int velikost) {
		textfieldVelikostOkoli.setText(String.valueOf(velikost));
	}
	
	public void vytvorOknoPravidlo() {
		oknoPravidlo = new OknoPravidlo(this);
		oknoPravidlo.setLocation(0, 0);
		oknoPravidlo.setVisible(true);
	}
	
	public Mrizka getMrizka() {
		return mrizka;
	}
	
	public String getReseni() {
		return textareaVysledneReseni.getText();
	}
	
	public int getMaximalniHloubka() {
		return Integer.parseInt(textfieldMaximalniHloubkaStromuPoKrizeni.getText());
	}
	
	public static boolean ulozJPanelJakoObrazek(Component panel){
        Dimension size = panel.getSize();
        BufferedImage image = new BufferedImage(size.width, size.height, BufferedImage.TYPE_INT_RGB);
        Graphics2D g2 = image.createGraphics();
        panel.paint(g2);
        try {
        	JFileChooser chooser = new JFileChooser();
            chooser.setCurrentDirectory( new File( "./") );
            int actionDialog = chooser.showSaveDialog(chooser.getParent());
            if (actionDialog == JFileChooser.APPROVE_OPTION) {
            	ImageIO.write(image, "png", new File(chooser.getSelectedFile() + ".png"));
            }
            return true;
        }
        catch(Exception e)
        {
            e.printStackTrace();
            return false;
        }
    }
	
}